import { CoreComponentModel } from "./model/CoreComponentModel";
/**
 * AbstractCoreComponent
 * provides shared functionality / properties across all core component controllers
 */
export declare abstract class AbstractCoreComponent implements CoreComponentModel {
    /** Force disable the placeholder at all times. This is useful for nested components. **/
    hidePlaceHolder: boolean;
    cqForceReload: boolean;
    cqPath: any;
    id: string;
    baseCssClass: any;
    dataLayer: {
        [key: string]: {
            [key: string]: string;
        };
    };
    /**
     * Method that needs to be overloaded, to determine whether the component should be treated as 'empty'
     */
    abstract get isEmpty(): boolean;
    /**
     * Returns whether to show the placeholder for the editors, if we cannot display the component.
     */
    get shouldShowPlaceHolder(): boolean;
    get isInEditor(): boolean;
    get dataLayerString(): string;
}
