import { InjectionToken } from "@angular/core";
import { NavigationItemModel } from "../model/NavigationItemModel";
/**
 * NavigationUtilityService
 * By providing a custom implementation, you can override various layouts components behaviour to mark an item active or not.
 * This is useful when you want to make it based on a browser router location.
 */
export interface NavigationUtilityService {
    isItemActive(item: NavigationItemModel): boolean;
}
export declare const NAVIGATION_UTIL_SERVICE: InjectionToken<NavigationUtilityService>;
export declare class DefaultNavigationUtilityServiceImpl implements NavigationUtilityService {
    /**
     * You may overrule this method to determine for example based on current URL / page context whether the item is active.
     * @param item
     */
    isItemActive(item: NavigationItemModel): boolean;
}
