import { AbstractCoreComponent, DefaultV1IsEmptyFn, AemAngularCoreWcmComponentsCore } from '@adobe/aem-core-components-angular-base/core';
export { DefaultV1IsEmptyFn } from '@adobe/aem-core-components-angular-base/core';
import { __decorate, __metadata } from 'tslib';
import { Input, Component, NgModule } from '@angular/core';
import { CommonModule } from '@angular/common';
import { BrowserModule } from '@angular/platform-browser';
import { RouterModule } from '@angular/router';

/*~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
 ~ Copyright 2020 Adobe Systems Incorporated
 ~
 ~ Licensed under the Apache License, Version 2.0 (the "License");
 ~ you may not use this file except in compliance with the License.
 ~ You may obtain a copy of the License at
 ~
 ~     http://www.apache.org/licenses/LICENSE-2.0
 ~
 ~ Unless required by applicable law or agreed to in writing, software
 ~ distributed under the License is distributed on an "AS IS" BASIS,
 ~ WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 ~ See the License for the specific language governing permissions and
 ~ limitations under the License.
 ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~*/
let DefaultV1Component = class DefaultV1Component extends AbstractCoreComponent {
    constructor() {
        super(...arguments);
        this.baseCssClass = 'cmp-default';
    }
    get isEmpty() {
        return DefaultV1IsEmptyFn(this);
    }
    get aHtml() {
        return this.html;
    }
};
__decorate([
    Input(),
    __metadata("design:type", Object)
], DefaultV1Component.prototype, "baseCssClass", void 0);
__decorate([
    Input(),
    __metadata("design:type", Object)
], DefaultV1Component.prototype, "html", void 0);
DefaultV1Component = __decorate([
    Component({
        selector: 'core-default-v1',
        template: "<!--/*~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~\n  ~ Copyright 2020 Adobe\n  ~\n  ~ Licensed under the Apache License, Version 2.0 (the \"License\");\n  ~ you may not use this file except in compliance with the License.\n  ~ You may obtain a copy of the License at\n  ~\n  ~     http://www.apache.org/licenses/LICENSE-2.0\n  ~\n  ~ Unless required by applicable law or agreed to in writing, software\n  ~ distributed under the License is distributed on an \"AS IS\" BASIS,\n  ~ WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.\n  ~ See the License for the specific language governing permissions and\n  ~ limitations under the License.\n  ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~*/-->\n\n<div *ngIf=\"isEmpty; then placeHolderBlock else componentBlock\"></div>\n\n<ng-template #placeHolderBlock>\n    <core-placeholder *ngIf=\"shouldShowPlaceHolder\" componentTitle=\"ButtonV1\"></core-placeholder>\n</ng-template>\n<ng-template #componentBlock>\n    <div id=\"{{id}}\" [attr.data-cmp-data-layer]=\"dataLayerString\" class=\"{{baseCssClass}}-wrapper\" [innerHTML]=\"aHtml | safeHtml\"></div>\n</ng-template>"
    })
], DefaultV1Component);

let AemAngularCoreWcmComponentsDefaultV1 = class AemAngularCoreWcmComponentsDefaultV1 {
};
AemAngularCoreWcmComponentsDefaultV1 = __decorate([
    NgModule({
        imports: [CommonModule, BrowserModule, RouterModule, AemAngularCoreWcmComponentsCore],
        declarations: [
            DefaultV1Component
        ],
        exports: [
            DefaultV1Component
        ],
        entryComponents: [
            DefaultV1Component,
        ],
    })
], AemAngularCoreWcmComponentsDefaultV1);

/*~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
 ~ Copyright 2020 Adobe Systems Incorporated
 ~
 ~ Licensed under the Apache License, Version 2.0 (the "License");
 ~ you may not use this file except in compliance with the License.
 ~ You may obtain a copy of the License at
 ~
 ~     http://www.apache.org/licenses/LICENSE-2.0
 ~
 ~ Unless required by applicable law or agreed to in writing, software
 ~ distributed under the License is distributed on an "AS IS" BASIS,
 ~ WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 ~ See the License for the specific language governing permissions and
 ~ limitations under the License.
 ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~*/

/**
 * Generated bundle index. Do not edit.
 */

export { AemAngularCoreWcmComponentsDefaultV1, DefaultV1Component };
//# sourceMappingURL=adobe-aem-core-components-angular-base-authoring-default-v1.js.map
