import { AbstractCoreComponent, DownloadV1IsEmptyFn, AemAngularCoreWcmComponentsCore } from '@adobe/aem-core-components-angular-base/core';
export { DownloadV1IsEmptyFn } from '@adobe/aem-core-components-angular-base/core';
import { __decorate, __metadata } from 'tslib';
import { EventEmitter, Input, Component, NgModule } from '@angular/core';
import { CommonModule } from '@angular/common';
import { BrowserModule } from '@angular/platform-browser';
import { RouterModule } from '@angular/router';

/*~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
 ~ Copyright 2020 Adobe Systems Incorporated
 ~
 ~ Licensed under the Apache License, Version 2.0 (the "License");
 ~ you may not use this file except in compliance with the License.
 ~ You may obtain a copy of the License at
 ~
 ~     http://www.apache.org/licenses/LICENSE-2.0
 ~
 ~ Unless required by applicable law or agreed to in writing, software
 ~ distributed under the License is distributed on an "AS IS" BASIS,
 ~ WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 ~ See the License for the specific language governing permissions and
 ~ limitations under the License.
 ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~*/
let DownloadV1Component = class DownloadV1Component extends AbstractCoreComponent {
    constructor() {
        super(...arguments);
        this.baseCssClass = 'cmp-download';
        this.titleType = 'h3';
        this.displayFilename = false;
        this.displaySize = false;
        this.displayFormat = false;
        this.labels = {
            filename: "File name",
            filesize: "Size",
            fileformat: "Format"
        };
        this.clickRequest = new EventEmitter();
    }
    onClick() {
        this.clickRequest.emit();
    }
    get containerCssClass() {
        return `${this.baseCssClass} ${(this.isInEditor) ? ' cq-dd-file' : ''}`;
    }
    get isDisplayingDescription() {
        return this.description !== null && this.description.trim().length > 0;
    }
    get isDisplayingProperties() {
        return this.isDisplayingFileformat || this.isDisplayingFilename || this.isDisplayingFilesize;
    }
    get isDisplayingFilesize() {
        return this.displaySize === true && this.displaySize != null && this.size.trim().length > 0;
    }
    get isDisplayingFileformat() {
        return this.displayFormat === true && this.format != null && this.format.trim().length > 0;
    }
    get isDisplayingFilename() {
        return this.displayFilename === true && this.filename != null && this.filename.trim().length > 0;
    }
    get isDisplayingDownloadButton() {
        return (!!this.url && this.url.trim().length > 0) && this.url && (!!this.actionText && this.actionText.trim().length > 0);
    }
    get isEmpty() {
        return DownloadV1IsEmptyFn(this);
    }
};
__decorate([
    Input(),
    __metadata("design:type", Object)
], DownloadV1Component.prototype, "baseCssClass", void 0);
__decorate([
    Input(),
    __metadata("design:type", Object)
], DownloadV1Component.prototype, "titleType", void 0);
__decorate([
    Input(),
    __metadata("design:type", Object)
], DownloadV1Component.prototype, "text", void 0);
__decorate([
    Input(),
    __metadata("design:type", Object)
], DownloadV1Component.prototype, "url", void 0);
__decorate([
    Input(),
    __metadata("design:type", Object)
], DownloadV1Component.prototype, "title", void 0);
__decorate([
    Input(),
    __metadata("design:type", Object)
], DownloadV1Component.prototype, "description", void 0);
__decorate([
    Input(),
    __metadata("design:type", Object)
], DownloadV1Component.prototype, "actionText", void 0);
__decorate([
    Input(),
    __metadata("design:type", Object)
], DownloadV1Component.prototype, "filename", void 0);
__decorate([
    Input(),
    __metadata("design:type", Object)
], DownloadV1Component.prototype, "format", void 0);
__decorate([
    Input(),
    __metadata("design:type", Object)
], DownloadV1Component.prototype, "size", void 0);
__decorate([
    Input(),
    __metadata("design:type", Object)
], DownloadV1Component.prototype, "extension", void 0);
__decorate([
    Input(),
    __metadata("design:type", Object)
], DownloadV1Component.prototype, "displayFilename", void 0);
__decorate([
    Input(),
    __metadata("design:type", Object)
], DownloadV1Component.prototype, "displaySize", void 0);
__decorate([
    Input(),
    __metadata("design:type", Object)
], DownloadV1Component.prototype, "displayFormat", void 0);
__decorate([
    Input(),
    __metadata("design:type", Object)
], DownloadV1Component.prototype, "labels", void 0);
DownloadV1Component = __decorate([
    Component({
        selector: 'core-download-v1',
        template: "<!--/*~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~\n  ~ Copyright 2020 Adobe\n  ~\n  ~ Licensed under the Apache License, Version 2.0 (the \"License\");\n  ~ you may not use this file except in compliance with the License.\n  ~ You may obtain a copy of the License at\n  ~\n  ~     http://www.apache.org/licenses/LICENSE-2.0\n  ~\n  ~ Unless required by applicable law or agreed to in writing, software\n  ~ distributed under the License is distributed on an \"AS IS\" BASIS,\n  ~ WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.\n  ~ See the License for the specific language governing permissions and\n  ~ limitations under the License.\n  ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~*/-->\n\n<div *ngIf=\"isEmpty; then placeHolderBlock else componentBlock\"></div>\n\n<ng-template #placeHolderBlock>\n    <core-placeholder *ngIf=\"shouldShowPlaceHolder\" componentTitle=\"DownloadV1\"></core-placeholder>\n</ng-template>\n\n<ng-template #componentBlock>\n    <div id=\"{{id}}\" [ngClass]=\"containerCssClass\" [attr.data-cmp-data-layer]=\"dataLayerString\">\n        <div [ngSwitch]=\"titleType\">\n            <h1 *ngSwitchCase=\"'h1'\" class=\"{{baseCssClass}}__title\">\n                <a *ngIf=\"url\" class=\"{{baseCssClass}}__title-link\" [href]=\"url\">{{title}}</a>\n            </h1>\n            <h2 *ngSwitchCase=\"'h2'\" class=\"{{baseCssClass}}__title\">\n                <a *ngIf=\"url\" class=\"{{baseCssClass}}__title-link\" [href]=\"url\">{{title}}</a>\n            </h2>\n            <h4 *ngSwitchCase=\"'h4'\" class=\"{{baseCssClass}}__title\">\n                <a *ngIf=\"url\" class=\"{{baseCssClass}}__title-link\" [href]=\"url\">{{title}}</a>\n            </h4>\n            <h5 *ngSwitchCase=\"'h5'\" class=\"{{baseCssClass}}__title\">\n                <a *ngIf=\"url\" class=\"{{baseCssClass}}__title-link\" [href]=\"url\">{{title}}</a>\n            </h5>\n            <h6 *ngSwitchCase=\"'h6'\" class=\"{{baseCssClass}}__title\">\n                <a *ngIf=\"url\" class=\"{{baseCssClass}}__title-link\" [href]=\"url\">{{title}}</a>\n            </h6>\n            <h3 *ngSwitchDefault  class=\"{{baseCssClass}}__title\">\n                <a *ngIf=\"url\" class=\"{{baseCssClass}}__title-link\" [href]=\"url\">{{title}}</a>\n            </h3>\n        </div>\n       \n        <div class=\"{{baseCssClass}}__description\" *ngIf=\"isDisplayingDescription\" [innerHTML]=\"description | safeHtml\"></div>\n        <dl *ngIf=\"isDisplayingProperties\" class=\"{{baseCssClass}}__properties\">\n            <div *ngIf=\"isDisplayingFilename\" class=\"{{baseCssClass}}__property {{baseCssClass}}__property--filename\">\n                <dt class=\"{{baseCssClass}}__property-label\">{{labels.filename}}</dt>\n                <dd class=\"{{baseCssClass}}__property-content\">{{filename}}</dd>\n            </div>\n            <div *ngIf=\"isDisplayingFilesize\" class=\"{{baseCssClass}}__property {{baseCssClass}}__property--size\">\n                <dt class=\"{{baseCssClass}}__property-label\">{{labels.filesize}}</dt>\n                <dd class=\"{{baseCssClass}}__property-content\">{{size}}</dd>\n            </div>\n            <div *ngIf=\"isDisplayingFileformat\" class=\"{{baseCssClass}}__property {{baseCssClass}}__property--format\">\n                <dt class=\"{{baseCssClass}}__property-label\">{{labels.fileformat}}</dt>\n                <dd class=\"{{baseCssClass}}__property-content\">{{format}}</dd>\n            </div>\n        </dl>\n        \n        <a *ngIf=\"isDisplayingDownloadButton\" class=\"{{baseCssClass}}__action\" href=\"{{url}}\">\n            <span class=\"{{baseCssClass}}__action-text\">{{actionText}}</span>\n        </a>\n    </div>\n</ng-template>"
    })
], DownloadV1Component);

let AemAngularCoreWcmComponentsDownloadV1 = class AemAngularCoreWcmComponentsDownloadV1 {
};
AemAngularCoreWcmComponentsDownloadV1 = __decorate([
    NgModule({
        imports: [CommonModule, BrowserModule, RouterModule, AemAngularCoreWcmComponentsCore],
        declarations: [
            DownloadV1Component
        ],
        exports: [
            DownloadV1Component
        ],
        entryComponents: [
            DownloadV1Component,
        ],
    })
], AemAngularCoreWcmComponentsDownloadV1);

/*~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
 ~ Copyright 2020 Adobe Systems Incorporated
 ~
 ~ Licensed under the Apache License, Version 2.0 (the "License");
 ~ you may not use this file except in compliance with the License.
 ~ You may obtain a copy of the License at
 ~
 ~     http://www.apache.org/licenses/LICENSE-2.0
 ~
 ~ Unless required by applicable law or agreed to in writing, software
 ~ distributed under the License is distributed on an "AS IS" BASIS,
 ~ WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 ~ See the License for the specific language governing permissions and
 ~ limitations under the License.
 ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~*/

/**
 * Generated bundle index. Do not edit.
 */

export { AemAngularCoreWcmComponentsDownloadV1, DownloadV1Component };
//# sourceMappingURL=adobe-aem-core-components-angular-base-authoring-download-v1.js.map
