import { __decorate, __metadata } from 'tslib';
import { Input, Component, NgModule } from '@angular/core';
import { AbstractRoutedCoreComponent, ImageV2IsEmptyFn, AemAngularCoreWcmComponentsCore } from '@adobe/aem-core-components-angular-base/core';
export { ImageV2IsEmptyFn } from '@adobe/aem-core-components-angular-base/core';
import { CommonModule } from '@angular/common';
import { BrowserModule } from '@angular/platform-browser';
import { RouterModule } from '@angular/router';

/*~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
 ~ Copyright 2020 Adobe Systems Incorporated
 ~
 ~ Licensed under the Apache License, Version 2.0 (the "License");
 ~ you may not use this file except in compliance with the License.
 ~ You may obtain a copy of the License at
 ~
 ~     http://www.apache.org/licenses/LICENSE-2.0
 ~
 ~ Unless required by applicable law or agreed to in writing, software
 ~ distributed under the License is distributed on an "AS IS" BASIS,
 ~ WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 ~ See the License for the specific language governing permissions and
 ~ limitations under the License.
 ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~*/
let ImageV2Component = class ImageV2Component extends AbstractRoutedCoreComponent {
    constructor() {
        super(...arguments);
        this.baseCssClass = 'cmp-image';
    }
    get hasTitle() {
        return !!this.title && this.title.trim().length > 0;
    }
    get hasLink() {
        return !!this.link && this.link.trim().length > 0;
    }
    get isEmpty() {
        return ImageV2IsEmptyFn(this);
    }
    get containerCssClass() {
        return `${this.baseCssClass} ${(this.isInEditor) ? ' cq-dd-image' : ''}`;
    }
};
__decorate([
    Input(),
    __metadata("design:type", Object)
], ImageV2Component.prototype, "baseCssClass", void 0);
__decorate([
    Input(),
    __metadata("design:type", Object)
], ImageV2Component.prototype, "src", void 0);
__decorate([
    Input(),
    __metadata("design:type", Object)
], ImageV2Component.prototype, "alt", void 0);
__decorate([
    Input(),
    __metadata("design:type", Object)
], ImageV2Component.prototype, "displayPopupTitle", void 0);
__decorate([
    Input(),
    __metadata("design:type", Object)
], ImageV2Component.prototype, "title", void 0);
__decorate([
    Input(),
    __metadata("design:type", Object)
], ImageV2Component.prototype, "link", void 0);
ImageV2Component = __decorate([
    Component({
        selector: 'core-image-v2',
        template: "<!--/*~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~\n  ~ Copyright 2020 Adobe\n  ~\n  ~ Licensed under the Apache License, Version 2.0 (the \"License\");\n  ~ you may not use this file except in compliance with the License.\n  ~ You may obtain a copy of the License at\n  ~\n  ~     http://www.apache.org/licenses/LICENSE-2.0\n  ~\n  ~ Unless required by applicable law or agreed to in writing, software\n  ~ distributed under the License is distributed on an \"AS IS\" BASIS,\n  ~ WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.\n  ~ See the License for the specific language governing permissions and\n  ~ limitations under the License.\n  ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~*/-->\n\n<div *ngIf=\"isEmpty; then placeHolderBlock else componentBlock\"></div>\n\n<ng-template #placeHolderBlock>\n    <core-placeholder *ngIf=\"shouldShowPlaceHolder\" componentTitle=\"ImageV2\"></core-placeholder>\n</ng-template>\n\n<ng-template #componentBlock>\n    <div *ngIf=\"hasLink; else staticBlock\" [ngClass]=\"containerCssClass\" [attr.data-cmp-data-layer]=\"dataLayerString\">\n        <ng-container *ngIf=\"routed\">\n            <ng-container *ngTemplateOutlet=\"routedLink\"></ng-container>\n        </ng-container>\n        <ng-container *ngIf=\"!routed\">\n            <ng-container *ngTemplateOutlet=\"staticLink\"></ng-container>\n        </ng-container>\n    </div>\n    <ng-template #staticBlock>\n        <div id=\"{{id}}\" [ngClass]=\"containerCssClass\" [attr.data-cmp-data-layer]=\"dataLayerString\">\n            <img [attr.src]=\"src\" class=\"{{baseCssClass}}__image\" alt=\"{{alt}}\" />\n            <meta *ngIf=\"hasTitle\" itemprop=\"caption\" content=\"{{title}}\">\n        </div>\n    </ng-template>\n</ng-template>\n\n\n<ng-template #routedLink>\n    <a routerLink=\"{{link}}\"\n       routerLinkActive=\"active\">\n        <img [attr.src]=\"src\" class=\"{{baseCssClass}}__image\" alt=\"{{alt}}\"/>\n        <meta *ngIf=\"hasTitle\" itemprop=\"caption\" content=\"{{title}}\">\n    </a>\n</ng-template>\n\n<ng-template #staticLink>\n    <a href=\"{{link}}\">\n        <img [attr.src]=\"src\" class=\"{{baseCssClass}}__image\" alt=\"{{alt}}\"/>\n        <meta *ngIf=\"hasTitle\" itemprop=\"caption\" content=\"{{title}}\">\n    </a>\n</ng-template>"
    })
], ImageV2Component);

let AemAngularCoreWcmComponentsImageV2 = class AemAngularCoreWcmComponentsImageV2 {
};
AemAngularCoreWcmComponentsImageV2 = __decorate([
    NgModule({
        imports: [CommonModule, BrowserModule, RouterModule, AemAngularCoreWcmComponentsCore],
        declarations: [
            ImageV2Component
        ],
        exports: [
            ImageV2Component
        ],
        entryComponents: [
            ImageV2Component,
        ],
    })
], AemAngularCoreWcmComponentsImageV2);

/*~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
 ~ Copyright 2020 Adobe Systems Incorporated
 ~
 ~ Licensed under the Apache License, Version 2.0 (the "License");
 ~ you may not use this file except in compliance with the License.
 ~ You may obtain a copy of the License at
 ~
 ~     http://www.apache.org/licenses/LICENSE-2.0
 ~
 ~ Unless required by applicable law or agreed to in writing, software
 ~ distributed under the License is distributed on an "AS IS" BASIS,
 ~ WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 ~ See the License for the specific language governing permissions and
 ~ limitations under the License.
 ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~*/

/**
 * Generated bundle index. Do not edit.
 */

export { AemAngularCoreWcmComponentsImageV2, ImageV2Component };
//# sourceMappingURL=adobe-aem-core-components-angular-base-authoring-image-v2.js.map
