import { __decorate, __metadata } from 'tslib';
import { Input, Component, NgModule } from '@angular/core';
import { AbstractRoutedCoreComponent, ListV2IsEmptyFn, AemAngularCoreWcmComponentsCore } from '@adobe/aem-core-components-angular-base/core';
export { ListV2IsEmptyFn } from '@adobe/aem-core-components-angular-base/core';
import { CommonModule } from '@angular/common';
import { BrowserModule } from '@angular/platform-browser';
import { RouterModule } from '@angular/router';

/*~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
 ~ Copyright 2020 Adobe Systems Incorporated
 ~
 ~ Licensed under the Apache License, Version 2.0 (the "License");
 ~ you may not use this file except in compliance with the License.
 ~ You may obtain a copy of the License at
 ~
 ~     http://www.apache.org/licenses/LICENSE-2.0
 ~
 ~ Unless required by applicable law or agreed to in writing, software
 ~ distributed under the License is distributed on an "AS IS" BASIS,
 ~ WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 ~ See the License for the specific language governing permissions and
 ~ limitations under the License.
 ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~*/
let ListV2Component = class ListV2Component extends AbstractRoutedCoreComponent {
    constructor() {
        super(...arguments);
        this.baseCssClass = 'cmp-list';
    }
    get isEmpty() {
        return ListV2IsEmptyFn(this);
    }
};
__decorate([
    Input(),
    __metadata("design:type", Array)
], ListV2Component.prototype, "items", void 0);
__decorate([
    Input(),
    __metadata("design:type", Object)
], ListV2Component.prototype, "dateFormatString", void 0);
__decorate([
    Input(),
    __metadata("design:type", Object)
], ListV2Component.prototype, "showDescription", void 0);
__decorate([
    Input(),
    __metadata("design:type", Object)
], ListV2Component.prototype, "showModificationDate", void 0);
__decorate([
    Input(),
    __metadata("design:type", Object)
], ListV2Component.prototype, "linkItems", void 0);
ListV2Component = __decorate([
    Component({
        selector: 'core-list-v2',
        template: "<!--/*~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~\n  ~ Copyright 2020 Adobe\n  ~\n  ~ Licensed under the Apache License, Version 2.0 (the \"License\");\n  ~ you may not use this file except in compliance with the License.\n  ~ You may obtain a copy of the License at\n  ~\n  ~     http://www.apache.org/licenses/LICENSE-2.0\n  ~\n  ~ Unless required by applicable law or agreed to in writing, software\n  ~ distributed under the License is distributed on an \"AS IS\" BASIS,\n  ~ WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.\n  ~ See the License for the specific language governing permissions and\n  ~ limitations under the License.\n  ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~*/-->\n\n<div *ngIf=\"isEmpty; then placeHolderBlock else componentBlock\"></div>\n\n<ng-template #placeHolderBlock>\n    <core-placeholder *ngIf=\"shouldShowPlaceHolder\" componentTitle=\"ListV2\"></core-placeholder>\n</ng-template>\n\n<ng-template #componentBlock>\n    <ul id=\"{{id}}\" class=\"{{baseCssClass}}\" [attr.data-cmp-data-layer]=\"dataLayerString\">\n        <li *ngFor=\"let item of items\" class=\"{{baseCssClass}}__item\">\n            <article>\n                <ng-container [ngTemplateOutlet]=\"item.url && linkItems ? linkedTitle : plainTitle\" [ngTemplateOutletContext]=\"{item:item}\"></ng-container>\n                <span *ngIf=\"item.description\" class=\"{{baseCssClass}}__item-description\">{{item.description}}</span>\n            </article>\n        </li>\n    </ul>\n</ng-template>\n\n\n<ng-template #linkedTitle let-item='item'>\n    <a *ngIf=\"isItemRouted(item)\" class=\"{{baseCssClass}}__item-link\"\n       routerLink=\"{{item.url}}\"\n       routerLinkActive=\"active\">\n        <ng-container [ngTemplateOutlet]=\"plainTitle\" [ngTemplateOutletContext]=\"{item:item}\"></ng-container>\n    </a>\n    <a *ngIf=\"!isItemRouted(item)\" href=\"{{item.url}}\" class=\"{{baseCssClass}}__item-link\">\n        <ng-container [ngTemplateOutlet]=\"plainTitle\" [ngTemplateOutletContext]=\"{item:item}\"></ng-container>\n    </a>\n</ng-template>\n\n<ng-template #plainTitle let-item='item'>\n    <span class=\"{{baseCssClass}}__item-title\">{{item.title}}</span>\n    <span *ngIf=\"showModificationDate && item.lastModifiedFormatted\" class=\"{{baseCssClass}}__item-date\">{{item.lastModifiedFormatted}}</span>\n</ng-template>"
    })
], ListV2Component);

let AemAngularCoreWcmComponentsListV2 = class AemAngularCoreWcmComponentsListV2 {
};
AemAngularCoreWcmComponentsListV2 = __decorate([
    NgModule({
        imports: [CommonModule, BrowserModule, RouterModule, AemAngularCoreWcmComponentsCore],
        declarations: [
            ListV2Component
        ],
        exports: [
            ListV2Component
        ],
        entryComponents: [
            ListV2Component,
        ],
    })
], AemAngularCoreWcmComponentsListV2);

/*~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
 ~ Copyright 2020 Adobe Systems Incorporated
 ~
 ~ Licensed under the Apache License, Version 2.0 (the "License");
 ~ you may not use this file except in compliance with the License.
 ~ You may obtain a copy of the License at
 ~
 ~     http://www.apache.org/licenses/LICENSE-2.0
 ~
 ~ Unless required by applicable law or agreed to in writing, software
 ~ distributed under the License is distributed on an "AS IS" BASIS,
 ~ WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 ~ See the License for the specific language governing permissions and
 ~ limitations under the License.
 ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~*/

/**
 * Generated bundle index. Do not edit.
 */

export { AemAngularCoreWcmComponentsListV2, ListV2Component };
//# sourceMappingURL=adobe-aem-core-components-angular-base-authoring-list-v2.js.map
