import { __decorate, __metadata } from 'tslib';
import { Input, Component, NgModule } from '@angular/core';
import { AbstractRoutedCoreComponent, TeaserV1IsEmptyFn, AemAngularCoreWcmComponentsCore } from '@adobe/aem-core-components-angular-base/core';
export { TeaserV1IsEmptyFn } from '@adobe/aem-core-components-angular-base/core';
import { CommonModule } from '@angular/common';
import { BrowserModule } from '@angular/platform-browser';
import { RouterModule } from '@angular/router';
import { AemAngularCoreWcmComponentsImageV2 } from '@adobe/aem-core-components-angular-base/authoring/image/v2';
import { AemAngularCoreWcmComponentsTitleV2 } from '@adobe/aem-core-components-angular-base/authoring/title/v2';

/*~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
 ~ Copyright 2020 Adobe Systems Incorporated
 ~
 ~ Licensed under the Apache License, Version 2.0 (the "License");
 ~ you may not use this file except in compliance with the License.
 ~ You may obtain a copy of the License at
 ~
 ~     http://www.apache.org/licenses/LICENSE-2.0
 ~
 ~ Unless required by applicable law or agreed to in writing, software
 ~ distributed under the License is distributed on an "AS IS" BASIS,
 ~ WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 ~ See the License for the specific language governing permissions and
 ~ limitations under the License.
 ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~*/
let TeaserV1Component = class TeaserV1Component extends AbstractRoutedCoreComponent {
    constructor() {
        super(...arguments);
        this.baseCssClass = 'cmp-teaser';
        this.actionsEnabled = false;
        this.actions = [];
    }
    get isEmpty() {
        return TeaserV1IsEmptyFn(this);
    }
    get isShowingImage() {
        return !!this.imagePath && this.imagePath.length > 0;
    }
};
__decorate([
    Input(),
    __metadata("design:type", Object)
], TeaserV1Component.prototype, "baseCssClass", void 0);
__decorate([
    Input(),
    __metadata("design:type", String)
], TeaserV1Component.prototype, "pretitle", void 0);
__decorate([
    Input(),
    __metadata("design:type", String)
], TeaserV1Component.prototype, "title", void 0);
__decorate([
    Input(),
    __metadata("design:type", String)
], TeaserV1Component.prototype, "description", void 0);
__decorate([
    Input(),
    __metadata("design:type", String)
], TeaserV1Component.prototype, "titleType", void 0);
__decorate([
    Input(),
    __metadata("design:type", String)
], TeaserV1Component.prototype, "linkURL", void 0);
__decorate([
    Input(),
    __metadata("design:type", Boolean)
], TeaserV1Component.prototype, "actionsEnabled", void 0);
__decorate([
    Input(),
    __metadata("design:type", Boolean)
], TeaserV1Component.prototype, "imageLinkHidden", void 0);
__decorate([
    Input(),
    __metadata("design:type", Boolean)
], TeaserV1Component.prototype, "titleLinkHidden", void 0);
__decorate([
    Input(),
    __metadata("design:type", Array)
], TeaserV1Component.prototype, "actions", void 0);
__decorate([
    Input(),
    __metadata("design:type", String)
], TeaserV1Component.prototype, "imagePath", void 0);
TeaserV1Component = __decorate([
    Component({
        selector: 'core-teaser-v1',
        template: "<!--/*~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~\n  ~ Copyright 2020 Adobe\n  ~\n  ~ Licensed under the Apache License, Version 2.0 (the \"License\");\n  ~ you may not use this file except in compliance with the License.\n  ~ You may obtain a copy of the License at\n  ~\n  ~     http://www.apache.org/licenses/LICENSE-2.0\n  ~\n  ~ Unless required by applicable law or agreed to in writing, software\n  ~ distributed under the License is distributed on an \"AS IS\" BASIS,\n  ~ WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.\n  ~ See the License for the specific language governing permissions and\n  ~ limitations under the License.\n  ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~*/-->\n\n<div *ngIf=\"isEmpty; then placeHolderBlock else componentBlock\"></div>\n\n<ng-template #placeHolderBlock>\n    <core-placeholder *ngIf=\"shouldShowPlaceHolder\" componentTitle=\"TeaserV1\"></core-placeholder>\n</ng-template>\n\n<ng-template #componentBlock>\n    <div id=\"{{id}}\" [attr.data-cmp-data-layer]=\"dataLayerString\" class=\"{{baseCssClass}}\">\n        \n        <div class=\"{{baseCssClass}}__image\" *ngIf=\"isShowingImage\">\n            <core-image-v2 [hidePlaceHolder]=\"true\" [src]=\"imagePath\" [title]=\"title\"></core-image-v2>\n        </div>\n        <div class=\"{{baseCssClass}}__content\">\n            <div *ngIf=\"pretitle\" class=\"{{baseCssClass}}__pretitle\">{{pretitle}}</div>\n            <core-title-v2 [hidePlaceHolder]=\"true\" [routed]=\"routed\" [linkURL]=\"linkURL\" [text]=\"title\" [type]=\"titleType\"></core-title-v2>\n            <div *ngIf=\"description\" class=\"{{baseCssClass}}__description\" [innerHTML]=\"description | safeHtml\"></div>\n            <div *ngIf=\"actionsEnabled\" class=\"{{baseCssClass}}__action-container\">\n                \n                <ng-container *ngFor=\"let action of actions\">\n                    \n                    <ng-template #normalLink>\n                        <a class=\"{{baseCssClass}}__action-link\" href=\"{{action.URL}}\">{{action.title}}</a>\n                    </ng-template>\n                    \n                    <ng-container *ngIf=\"routed || action.routed; else normalLink\">\n                        <a class=\"{{baseCssClass}}__action-link\"\n                           routerLink=\"{{action.URL}}\"\n                           routerLinkActive=\"active\"\n                        >{{action.title}}</a>\n                    </ng-container>\n                    \n                </ng-container>\n            </div>\n    \n        </div>\n\n    </div>\n   \n</ng-template>\n\n"
    })
], TeaserV1Component);

/*~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
 ~ Copyright 2020 Adobe Systems Incorporated
 ~
 ~ Licensed under the Apache License, Version 2.0 (the "License");
 ~ you may not use this file except in compliance with the License.
 ~ You may obtain a copy of the License at
 ~
 ~     http://www.apache.org/licenses/LICENSE-2.0
 ~
 ~ Unless required by applicable law or agreed to in writing, software
 ~ distributed under the License is distributed on an "AS IS" BASIS,
 ~ WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 ~ See the License for the specific language governing permissions and
 ~ limitations under the License.
 ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~*/
let AemAngularCoreWcmComponentsTeaserV1 = class AemAngularCoreWcmComponentsTeaserV1 {
};
AemAngularCoreWcmComponentsTeaserV1 = __decorate([
    NgModule({
        imports: [CommonModule, BrowserModule, RouterModule, AemAngularCoreWcmComponentsCore, AemAngularCoreWcmComponentsImageV2, AemAngularCoreWcmComponentsTitleV2],
        declarations: [
            TeaserV1Component
        ],
        exports: [
            TeaserV1Component
        ],
        entryComponents: [
            TeaserV1Component
        ],
    })
], AemAngularCoreWcmComponentsTeaserV1);

/*~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
 ~ Copyright 2020 Adobe Systems Incorporated
 ~
 ~ Licensed under the Apache License, Version 2.0 (the "License");
 ~ you may not use this file except in compliance with the License.
 ~ You may obtain a copy of the License at
 ~
 ~     http://www.apache.org/licenses/LICENSE-2.0
 ~
 ~ Unless required by applicable law or agreed to in writing, software
 ~ distributed under the License is distributed on an "AS IS" BASIS,
 ~ WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 ~ See the License for the specific language governing permissions and
 ~ limitations under the License.
 ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~*/

/**
 * Generated bundle index. Do not edit.
 */

export { AemAngularCoreWcmComponentsTeaserV1, TeaserV1Component };
//# sourceMappingURL=adobe-aem-core-components-angular-base-authoring-teaser-v1.js.map
