import { __decorate, __metadata } from 'tslib';
import { Input, Component, Pipe, InjectionToken, Injectable, NgModule } from '@angular/core';
import { DomSanitizer, BrowserModule } from '@angular/platform-browser';
import { CommonModule } from '@angular/common';
import { RouterModule } from '@angular/router';

/*~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
 ~ Copyright 2020 Adobe Systems Incorporated
 ~
 ~ Licensed under the Apache License, Version 2.0 (the "License");
 ~ you may not use this file except in compliance with the License.
 ~ You may obtain a copy of the License at
 ~
 ~     http://www.apache.org/licenses/LICENSE-2.0
 ~
 ~ Unless required by applicable law or agreed to in writing, software
 ~ distributed under the License is distributed on an "AS IS" BASIS,
 ~ WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 ~ See the License for the specific language governing permissions and
 ~ limitations under the License.
 ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~*/
var EditPlaceholderComponent_1;
let EditPlaceholderComponent = EditPlaceholderComponent_1 = class EditPlaceholderComponent {
    get emptyText() {
        const part1 = (this.componentTitle != null && this.componentTitle.length > 0) ? this.componentTitle + ' - ' : '';
        const part2 = (this.emptyTextAppend != null) ? this.emptyTextAppend : EditPlaceholderComponent_1.DEFAULT_EMPTY_TEXT_LABEL;
        return part1 + part2;
    }
    get placeHolderCssClass() {
        return 'cq-placeholder ' + this.classAppend;
    }
};
EditPlaceholderComponent.DEFAULT_EMPTY_TEXT_LABEL = 'Please configure the component';
__decorate([
    Input(),
    __metadata("design:type", String)
], EditPlaceholderComponent.prototype, "classAppend", void 0);
__decorate([
    Input(),
    __metadata("design:type", String)
], EditPlaceholderComponent.prototype, "componentTitle", void 0);
__decorate([
    Input(),
    __metadata("design:type", String)
], EditPlaceholderComponent.prototype, "emptyTextAppend", void 0);
EditPlaceholderComponent = EditPlaceholderComponent_1 = __decorate([
    Component({
        selector: 'core-placeholder',
        template: "<!--/*~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~\n  ~ Copyright 2020 Adobe\n  ~\n  ~ Licensed under the Apache License, Version 2.0 (the \"License\");\n  ~ you may not use this file except in compliance with the License.\n  ~ You may obtain a copy of the License at\n  ~\n  ~     http://www.apache.org/licenses/LICENSE-2.0\n  ~\n  ~ Unless required by applicable law or agreed to in writing, software\n  ~ distributed under the License is distributed on an \"AS IS\" BASIS,\n  ~ WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.\n  ~ See the License for the specific language governing permissions and\n  ~ limitations under the License.\n  ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~*/-->\n\n<div [ngClass]=\"placeHolderCssClass\">{{emptyText}}</div>"
    })
], EditPlaceholderComponent);

/*~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
 ~ Copyright 2020 Adobe Systems Incorporated
 ~
 ~ Licensed under the Apache License, Version 2.0 (the "License");
 ~ you may not use this file except in compliance with the License.
 ~ You may obtain a copy of the License at
 ~
 ~     http://www.apache.org/licenses/LICENSE-2.0
 ~
 ~ Unless required by applicable law or agreed to in writing, software
 ~ distributed under the License is distributed on an "AS IS" BASIS,
 ~ WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 ~ See the License for the specific language governing permissions and
 ~ limitations under the License.
 ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~*/
let SafeHtmlPipe = class SafeHtmlPipe {
    constructor(sanitizer) {
        this.sanitizer = sanitizer;
    }
    transform(style) {
        return this.sanitizer.bypassSecurityTrustHtml(style);
    }
};
SafeHtmlPipe.ctorParameters = () => [
    { type: DomSanitizer }
];
SafeHtmlPipe = __decorate([
    Pipe({ name: 'safeHtml' }),
    __metadata("design:paramtypes", [DomSanitizer])
], SafeHtmlPipe);

/*~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
 ~ Copyright 2020 Adobe Systems Incorporated
 ~
 ~ Licensed under the Apache License, Version 2.0 (the "License");
 ~ you may not use this file except in compliance with the License.
 ~ You may obtain a copy of the License at
 ~
 ~     http://www.apache.org/licenses/LICENSE-2.0
 ~
 ~ Unless required by applicable law or agreed to in writing, software
 ~ distributed under the License is distributed on an "AS IS" BASIS,
 ~ WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 ~ See the License for the specific language governing permissions and
 ~ limitations under the License.
 ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~*/
const NAVIGATION_UTIL_SERVICE = new InjectionToken('NAVIGATION_UTIL_SERVICE');
let DefaultNavigationUtilityServiceImpl = class DefaultNavigationUtilityServiceImpl {
    /**
     * You may overrule this method to determine for example based on current URL / page context whether the item is active.
     * @param item
     */
    isItemActive(item) {
        return item.active;
    }
};
DefaultNavigationUtilityServiceImpl = __decorate([
    Injectable()
], DefaultNavigationUtilityServiceImpl);

/*~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
 ~ Copyright 2020 Adobe Systems Incorporated
 ~
 ~ Licensed under the Apache License, Version 2.0 (the "License");
 ~ you may not use this file except in compliance with the License.
 ~ You may obtain a copy of the License at
 ~
 ~     http://www.apache.org/licenses/LICENSE-2.0
 ~
 ~ Unless required by applicable law or agreed to in writing, software
 ~ distributed under the License is distributed on an "AS IS" BASIS,
 ~ WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 ~ See the License for the specific language governing permissions and
 ~ limitations under the License.
 ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~*/
let AemAngularCoreWcmComponentsCore = class AemAngularCoreWcmComponentsCore {
};
AemAngularCoreWcmComponentsCore = __decorate([
    NgModule({
        imports: [CommonModule, BrowserModule, RouterModule],
        providers: [
            { provide: NAVIGATION_UTIL_SERVICE, useClass: DefaultNavigationUtilityServiceImpl }
        ],
        exports: [
            EditPlaceholderComponent,
            SafeHtmlPipe
        ],
        declarations: [
            EditPlaceholderComponent,
            SafeHtmlPipe
        ],
        entryComponents: [
            EditPlaceholderComponent,
        ],
    })
], AemAngularCoreWcmComponentsCore);

/*
 *  Copyright 2020 Adobe
 *
 *  Licensed under the Apache License, Version 2.0 (the "License");
 *  you may not use this file except in compliance with the License.
 *  You may obtain a copy of the License at
 *
 *      http://www.apache.org/licenses/LICENSE-2.0
 *
 *  Unless required by applicable law or agreed to in writing, software
 *  distributed under the License is distributed on an "AS IS" BASIS,
 *  WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 *  See the License for the specific language governing permissions and
 *  limitations under the License.
 */
class MetaUtils {
    /**
     * Returns if the code executes in the browser context or not by checking for the
     * existance of the window object
     *
     * @returns {Boolean} the result of the check of the existance of the window object
     */
    static isBrowser() {
        try {
            return typeof window !== 'undefined';
        }
        catch (e) {
            return false;
        }
    }
    static getWcmMode() {
        return MetaUtils.getMetaPropertyValue('cq:wcmmode');
    }
    static isInEditor() {
        return this.getWcmMode() === 'edit';
    }
    /**
     * Returns the value of the meta property with the given key
     *
     * @param {string} propertyName  - name of the meta property
     * @return {string|undefined}
     */
    static getMetaPropertyValue(propertyName) {
        if (this.isBrowser()) {
            const meta = document.head.querySelector('meta[property="' + propertyName + '"]');
            // @ts-ignore
            return meta && meta.content;
        }
    }
}

/*~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
 ~ Copyright 2020 Adobe Systems Incorporated
 ~
 ~ Licensed under the Apache License, Version 2.0 (the "License");
 ~ you may not use this file except in compliance with the License.
 ~ You may obtain a copy of the License at
 ~
 ~     http://www.apache.org/licenses/LICENSE-2.0
 ~
 ~ Unless required by applicable law or agreed to in writing, software
 ~ distributed under the License is distributed on an "AS IS" BASIS,
 ~ WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 ~ See the License for the specific language governing permissions and
 ~ limitations under the License.
 ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~*/
/**
 * AbstractCoreComponent
 * provides shared functionality / properties across all core component controllers
 */
class AbstractCoreComponent {
    constructor() {
        /** Force disable the placeholder at all times. This is useful for nested components. **/
        this.hidePlaceHolder = false;
        this.cqForceReload = false;
        this.dataLayer = {};
    }
    /**
     * Returns whether to show the placeholder for the editors, if we cannot display the component.
     */
    get shouldShowPlaceHolder() {
        return (this.isEmpty && this.isInEditor === true && this.hidePlaceHolder !== true);
    }
    get isInEditor() {
        return MetaUtils.isInEditor();
    }
    get dataLayerString() {
        return this.dataLayer ? JSON.stringify(this.dataLayer) : "";
    }
}
__decorate([
    Input(),
    __metadata("design:type", Boolean)
], AbstractCoreComponent.prototype, "hidePlaceHolder", void 0);
__decorate([
    Input(),
    __metadata("design:type", Object)
], AbstractCoreComponent.prototype, "cqForceReload", void 0);
__decorate([
    Input(),
    __metadata("design:type", Object)
], AbstractCoreComponent.prototype, "cqPath", void 0);
__decorate([
    Input(),
    __metadata("design:type", String)
], AbstractCoreComponent.prototype, "id", void 0);
__decorate([
    Input(),
    __metadata("design:type", Object)
], AbstractCoreComponent.prototype, "baseCssClass", void 0);
__decorate([
    Input(),
    __metadata("design:type", Object)
], AbstractCoreComponent.prototype, "dataLayer", void 0);

/*~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
 ~ Copyright 2020 Adobe Systems Incorporated
 ~
 ~ Licensed under the Apache License, Version 2.0 (the "License");
 ~ you may not use this file except in compliance with the License.
 ~ You may obtain a copy of the License at
 ~
 ~     http://www.apache.org/licenses/LICENSE-2.0
 ~
 ~ Unless required by applicable law or agreed to in writing, software
 ~ distributed under the License is distributed on an "AS IS" BASIS,
 ~ WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 ~ See the License for the specific language governing permissions and
 ~ limitations under the License.
 ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~*/
/**
 * AbstractRoutedCoreComponent
 * This core component contains 1 or more links.
 * We want to be able to control SPA routing with a property coming from the model.
 */
class AbstractRoutedCoreComponent extends AbstractCoreComponent {
    /**
     * Determine if an individual item (such as navigation entry or list link) should be routed or not.
     *
     * item: the entry item in a component, think of a link that belongs to a collection of links in the navigation.
     *       we can specify here to disable routing, or to overrule routing of the base component
     * base component: the component itself, think of the navigation itself.
     *       we can specify the default behaviour of all items here.
     *
     * The following scenarios result in routing:
     * Scenario 1: The item or the base component don't have anything set, we assume true (except for external links starting with http)
     * Scenario 2: The base component has routing on false, but the item has it on true (item takes precedence)
     * Scenario 3: The base component or item, or both, have the routing values set to true.
     *
     * The following scenario does NOT result in routing:
     * Scenario 1: The base component has routing enabled, but the item has it set to false
     * @param item
     */
    isItemRouted(item) {
        const itemRoutedSpecified = typeof item.routed === 'boolean';
        const componentRoutedSpecified = typeof this.routed === 'boolean';
        if (!itemRoutedSpecified && !componentRoutedSpecified) {
            //if nothing specified, assume we route.
            return true;
        }
        else if (itemRoutedSpecified) {
            //only the item is specified
            return item.routed;
        }
        else if (componentRoutedSpecified) {
            return this.routed;
        }
    }
}
__decorate([
    Input(),
    __metadata("design:type", Object)
], AbstractRoutedCoreComponent.prototype, "routed", void 0);

function ButtonV1IsEmptyFn(props) {
    return props.text == null || props.text.trim().length === 0;
}

function DefaultV1IsEmptyFn(props) {
    return props.html == null || props.html.trim().length === 0;
}

function DownloadV1IsEmptyFn(props) {
    return props.url == null || props.url.trim().length === 0;
}

function ImageV2IsEmptyFn(props) {
    return (!props.src) || props.src.length === 0;
}

function ListV2IsEmptyFn(props) {
    return props.items == null || props.items.length === 0;
}

function SeparatorV1IsEmptyFn() {
    return false;
}

function TeaserV1IsEmptyFn(props) {
    return !props.title || !props.description;
}

function TextV2IsEmptyFn(props) {
    return props.text == null || props.text.trim().length === 0;
}

function TitleV2IsEmptyFn(props) {
    return props.text == null || props.text.trim().length === 0;
}

function BreadCrumbV2IsEmptyFn(props) {
    return props.items == null || props.items.length === 0;
}

function NavigationV1IsEmptyFn(props) {
    return props.items == null || props.items.length === 0;
}

/*~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
 ~ Copyright 2020 Adobe Systems Incorporated
 ~
 ~ Licensed under the Apache License, Version 2.0 (the "License");
 ~ you may not use this file except in compliance with the License.
 ~ You may obtain a copy of the License at
 ~
 ~     http://www.apache.org/licenses/LICENSE-2.0
 ~
 ~ Unless required by applicable law or agreed to in writing, software
 ~ distributed under the License is distributed on an "AS IS" BASIS,
 ~ WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 ~ See the License for the specific language governing permissions and
 ~ limitations under the License.
 ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~*/

/**
 * Generated bundle index. Do not edit.
 */

export { AbstractCoreComponent, AbstractRoutedCoreComponent, AemAngularCoreWcmComponentsCore, BreadCrumbV2IsEmptyFn, ButtonV1IsEmptyFn, DefaultNavigationUtilityServiceImpl, DefaultV1IsEmptyFn, DownloadV1IsEmptyFn, EditPlaceholderComponent, ImageV2IsEmptyFn, ListV2IsEmptyFn, MetaUtils, NAVIGATION_UTIL_SERVICE, NavigationV1IsEmptyFn, SafeHtmlPipe, SeparatorV1IsEmptyFn, TeaserV1IsEmptyFn, TextV2IsEmptyFn, TitleV2IsEmptyFn };
//# sourceMappingURL=adobe-aem-core-components-angular-base-core.js.map
