import { ButtonV1IsEmptyFn, AbstractRoutedCoreComponent, AemAngularCoreWcmComponentsCore } from '@adobe/aem-core-components-angular-base/core';
export { ButtonV1IsEmptyFn } from '@adobe/aem-core-components-angular-base/core';
import { __extends, __decorate, __metadata } from 'tslib';
import { EventEmitter, Input, Output, Component, NgModule } from '@angular/core';
import { CommonModule } from '@angular/common';
import { BrowserModule } from '@angular/platform-browser';
import { RouterModule } from '@angular/router';

/*~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
 ~ Copyright 2020 Adobe Systems Incorporated
 ~
 ~ Licensed under the Apache License, Version 2.0 (the "License");
 ~ you may not use this file except in compliance with the License.
 ~ You may obtain a copy of the License at
 ~
 ~     http://www.apache.org/licenses/LICENSE-2.0
 ~
 ~ Unless required by applicable law or agreed to in writing, software
 ~ distributed under the License is distributed on an "AS IS" BASIS,
 ~ WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 ~ See the License for the specific language governing permissions and
 ~ limitations under the License.
 ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~*/
var ButtonV1Component = /** @class */ (function (_super) {
    __extends(ButtonV1Component, _super);
    function ButtonV1Component() {
        var _this = _super !== null && _super.apply(this, arguments) || this;
        _this.baseCssClass = 'cmp-button';
        _this.clickRequest = new EventEmitter();
        return _this;
    }
    Object.defineProperty(ButtonV1Component.prototype, "iconClass", {
        get: function () {
            return this.baseCssClass + "__icon " + this.baseCssClass + "__icon--" + this.icon;
        },
        enumerable: true,
        configurable: true
    });
    ButtonV1Component.prototype.onClick = function () {
        this.clickRequest.emit();
    };
    Object.defineProperty(ButtonV1Component.prototype, "isEmpty", {
        get: function () {
            return ButtonV1IsEmptyFn(this);
        },
        enumerable: true,
        configurable: true
    });
    __decorate([
        Input(),
        __metadata("design:type", Object)
    ], ButtonV1Component.prototype, "baseCssClass", void 0);
    __decorate([
        Input(),
        __metadata("design:type", Object)
    ], ButtonV1Component.prototype, "text", void 0);
    __decorate([
        Input(),
        __metadata("design:type", Object)
    ], ButtonV1Component.prototype, "link", void 0);
    __decorate([
        Input(),
        __metadata("design:type", Object)
    ], ButtonV1Component.prototype, "icon", void 0);
    __decorate([
        Input(),
        __metadata("design:type", Object)
    ], ButtonV1Component.prototype, "ariaLabel", void 0);
    __decorate([
        Output(),
        __metadata("design:type", Object)
    ], ButtonV1Component.prototype, "clickRequest", void 0);
    ButtonV1Component = __decorate([
        Component({
            selector: 'core-button-v1',
            template: "<!--/*~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~\n  ~ Copyright 2020 Adobe\n  ~\n  ~ Licensed under the Apache License, Version 2.0 (the \"License\");\n  ~ you may not use this file except in compliance with the License.\n  ~ You may obtain a copy of the License at\n  ~\n  ~     http://www.apache.org/licenses/LICENSE-2.0\n  ~\n  ~ Unless required by applicable law or agreed to in writing, software\n  ~ distributed under the License is distributed on an \"AS IS\" BASIS,\n  ~ WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.\n  ~ See the License for the specific language governing permissions and\n  ~ limitations under the License.\n  ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~*/-->\n\n<div *ngIf=\"isEmpty; then placeHolderBlock else componentBlock\"></div>\n\n<ng-template #placeHolderBlock>\n    <core-placeholder *ngIf=\"shouldShowPlaceHolder\" componentTitle=\"ButtonV1\"></core-placeholder>\n</ng-template>\n<ng-template #componentBlock>\n    <div *ngIf=\"link; then linkBlock else staticBlock\"></div>\n</ng-template>\n\n<ng-template #linkBlock>\n    <ng-container *ngIf=\"routed\">\n        <ng-container *ngTemplateOutlet=\"routedLink\"></ng-container>\n    </ng-container>\n    <ng-container *ngIf=\"!routed\">\n        <ng-container *ngTemplateOutlet=\"staticLink\"></ng-container>\n    </ng-container>\n</ng-template>\n<ng-template #staticBlock>\n    <button [attr.data-cmp-data-layer]=\"dataLayerString\"\n            (click)=\"onClick()\"\n            type=\"button\"\n            id=\"{{id}}\"\n            class=\"{{baseCssClass}}\">\n        <span *ngIf=\"icon\" class=\"{{iconClass}}\"></span>\n        <span class=\"{{baseCssClass}}__text\" [innerText]=\"text\"></span>\n    </button>\n</ng-template>\n\n<ng-template #routedLink>\n    <a [attr.data-cmp-data-layer]=\"dataLayerString\"\n       id=\"{{id}}\"\n       routerLink=\"{{link}}\"\n       routerLinkActive=\"active\"\n       (click)=\"onClick()\"\n       class=\"{{baseCssClass}}\">\n        <span *ngIf=\"icon\" class=\"{{iconClass}}\"></span>\n        <span class=\"{{baseCssClass}}__text\" [innerText]=\"text\"></span>\n    </a>\n</ng-template>\n\n<ng-template #staticLink>\n    <a [href]=\"link\"\n       (click)=\"onClick()\"\n       [attr.data-cmp-data-layer]=\"dataLayerString\"\n       id=\"{{id}}\"\n       class=\"{{baseCssClass}}\"\n    >\n        <span *ngIf=\"icon\" class=\"{{iconClass}}\"></span>\n        <span class=\"{{baseCssClass}}__text\" [innerText]=\"text\"></span>\n    </a>\n</ng-template>",
            host: {
                '[attr.data-cq-data-path]': 'cqPath'
            }
        })
    ], ButtonV1Component);
    return ButtonV1Component;
}(AbstractRoutedCoreComponent));

/*~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
 ~ Copyright 2020 Adobe Systems Incorporated
 ~
 ~ Licensed under the Apache License, Version 2.0 (the "License");
 ~ you may not use this file except in compliance with the License.
 ~ You may obtain a copy of the License at
 ~
 ~     http://www.apache.org/licenses/LICENSE-2.0
 ~
 ~ Unless required by applicable law or agreed to in writing, software
 ~ distributed under the License is distributed on an "AS IS" BASIS,
 ~ WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 ~ See the License for the specific language governing permissions and
 ~ limitations under the License.
 ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~*/
var AemAngularCoreWcmComponentsButtonV1 = /** @class */ (function () {
    function AemAngularCoreWcmComponentsButtonV1() {
    }
    AemAngularCoreWcmComponentsButtonV1 = __decorate([
        NgModule({
            imports: [CommonModule, BrowserModule, RouterModule, AemAngularCoreWcmComponentsCore],
            declarations: [
                ButtonV1Component
            ],
            exports: [
                ButtonV1Component
            ],
            entryComponents: [
                ButtonV1Component,
            ],
        })
    ], AemAngularCoreWcmComponentsButtonV1);
    return AemAngularCoreWcmComponentsButtonV1;
}());

/*~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
 ~ Copyright 2020 Adobe Systems Incorporated
 ~
 ~ Licensed under the Apache License, Version 2.0 (the "License");
 ~ you may not use this file except in compliance with the License.
 ~ You may obtain a copy of the License at
 ~
 ~     http://www.apache.org/licenses/LICENSE-2.0
 ~
 ~ Unless required by applicable law or agreed to in writing, software
 ~ distributed under the License is distributed on an "AS IS" BASIS,
 ~ WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 ~ See the License for the specific language governing permissions and
 ~ limitations under the License.
 ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~*/

/**
 * Generated bundle index. Do not edit.
 */

export { AemAngularCoreWcmComponentsButtonV1, ButtonV1Component };
//# sourceMappingURL=adobe-aem-core-components-angular-base-authoring-button-v1.js.map
