import { __extends, __decorate, __metadata } from 'tslib';
import { Input, Component, NgModule } from '@angular/core';
import { TextV2IsEmptyFn, AbstractCoreComponent, AemAngularCoreWcmComponentsCore } from '@adobe/aem-core-components-angular-base/core';
export { TextV2IsEmptyFn } from '@adobe/aem-core-components-angular-base/core';
import { CommonModule } from '@angular/common';
import { BrowserModule } from '@angular/platform-browser';
import { RouterModule } from '@angular/router';

/*~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
 ~ Copyright 2020 Adobe Systems Incorporated
 ~
 ~ Licensed under the Apache License, Version 2.0 (the "License");
 ~ you may not use this file except in compliance with the License.
 ~ You may obtain a copy of the License at
 ~
 ~     http://www.apache.org/licenses/LICENSE-2.0
 ~
 ~ Unless required by applicable law or agreed to in writing, software
 ~ distributed under the License is distributed on an "AS IS" BASIS,
 ~ WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 ~ See the License for the specific language governing permissions and
 ~ limitations under the License.
 ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~*/
var TextV2Component = /** @class */ (function (_super) {
    __extends(TextV2Component, _super);
    function TextV2Component() {
        var _this = _super !== null && _super.apply(this, arguments) || this;
        _this.baseCssClass = 'cmp-text';
        _this.richText = false;
        return _this;
    }
    Object.defineProperty(TextV2Component.prototype, "isEmpty", {
        get: function () {
            return TextV2IsEmptyFn(this);
        },
        enumerable: true,
        configurable: true
    });
    __decorate([
        Input(),
        __metadata("design:type", Object)
    ], TextV2Component.prototype, "baseCssClass", void 0);
    __decorate([
        Input(),
        __metadata("design:type", Object)
    ], TextV2Component.prototype, "text", void 0);
    __decorate([
        Input(),
        __metadata("design:type", Object)
    ], TextV2Component.prototype, "richText", void 0);
    TextV2Component = __decorate([
        Component({
            selector: 'core-text-v2',
            template: "<!--/*~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~\n  ~ Copyright 2020 Adobe\n  ~\n  ~ Licensed under the Apache License, Version 2.0 (the \"License\");\n  ~ you may not use this file except in compliance with the License.\n  ~ You may obtain a copy of the License at\n  ~\n  ~     http://www.apache.org/licenses/LICENSE-2.0\n  ~\n  ~ Unless required by applicable law or agreed to in writing, software\n  ~ distributed under the License is distributed on an \"AS IS\" BASIS,\n  ~ WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.\n  ~ See the License for the specific language governing permissions and\n  ~ limitations under the License.\n  ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~*/-->\n\n<div *ngIf=\"isEmpty; then placeHolderBlock else componentBlock\"></div>\n\n<ng-template #placeHolderBlock>\n    <core-placeholder *ngIf=\"shouldShowPlaceHolder\" componentTitle=\"TextV2\"></core-placeholder>\n</ng-template>\n\n<ng-template #componentBlock>\n    <ng-container *ngIf=\"richText; else plainTextBlock\">\n        <div id=\"{{id}}\" class=\"{{baseCssClass}}\" [innerHTML]=\"text | safeHtml\" [attr.data-cmp-data-layer]=\"dataLayerString\"></div>\n    </ng-container>\n    \n</ng-template>\n\n\n\n<ng-template #plainTextBlock>\n    <div id=\"{{id}}\" class=\"{{baseCssClass}}\" [attr.data-cmp-data-layer]=\"dataLayerString\">\n        <p class=\"{{baseCssClass}}__paragraph\">{{text}}</p>\n    </div>\n</ng-template>"
        })
    ], TextV2Component);
    return TextV2Component;
}(AbstractCoreComponent));

/*~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
 ~ Copyright 2020 Adobe Systems Incorporated
 ~
 ~ Licensed under the Apache License, Version 2.0 (the "License");
 ~ you may not use this file except in compliance with the License.
 ~ You may obtain a copy of the License at
 ~
 ~     http://www.apache.org/licenses/LICENSE-2.0
 ~
 ~ Unless required by applicable law or agreed to in writing, software
 ~ distributed under the License is distributed on an "AS IS" BASIS,
 ~ WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 ~ See the License for the specific language governing permissions and
 ~ limitations under the License.
 ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~*/
var AemAngularCoreWcmComponentsTextV2 = /** @class */ (function () {
    function AemAngularCoreWcmComponentsTextV2() {
    }
    AemAngularCoreWcmComponentsTextV2 = __decorate([
        NgModule({
            imports: [CommonModule, BrowserModule, RouterModule, AemAngularCoreWcmComponentsCore],
            declarations: [
                TextV2Component
            ],
            exports: [
                TextV2Component
            ],
            entryComponents: [
                TextV2Component,
            ],
        })
    ], AemAngularCoreWcmComponentsTextV2);
    return AemAngularCoreWcmComponentsTextV2;
}());

/*~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
 ~ Copyright 2020 Adobe Systems Incorporated
 ~
 ~ Licensed under the Apache License, Version 2.0 (the "License");
 ~ you may not use this file except in compliance with the License.
 ~ You may obtain a copy of the License at
 ~
 ~     http://www.apache.org/licenses/LICENSE-2.0
 ~
 ~ Unless required by applicable law or agreed to in writing, software
 ~ distributed under the License is distributed on an "AS IS" BASIS,
 ~ WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 ~ See the License for the specific language governing permissions and
 ~ limitations under the License.
 ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~*/

/**
 * Generated bundle index. Do not edit.
 */

export { AemAngularCoreWcmComponentsTextV2, TextV2Component };
//# sourceMappingURL=adobe-aem-core-components-angular-base-authoring-text-v2.js.map
