import { __extends, __decorate, __metadata } from 'tslib';
import { Input, Component, NgModule } from '@angular/core';
import { TitleV2IsEmptyFn, AbstractRoutedCoreComponent, AemAngularCoreWcmComponentsCore } from '@adobe/aem-core-components-angular-base/core';
export { TitleV2IsEmptyFn } from '@adobe/aem-core-components-angular-base/core';
import { CommonModule } from '@angular/common';
import { BrowserModule } from '@angular/platform-browser';
import { RouterModule } from '@angular/router';

/*~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
 ~ Copyright 2020 Adobe Systems Incorporated
 ~
 ~ Licensed under the Apache License, Version 2.0 (the "License");
 ~ you may not use this file except in compliance with the License.
 ~ You may obtain a copy of the License at
 ~
 ~     http://www.apache.org/licenses/LICENSE-2.0
 ~
 ~ Unless required by applicable law or agreed to in writing, software
 ~ distributed under the License is distributed on an "AS IS" BASIS,
 ~ WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 ~ See the License for the specific language governing permissions and
 ~ limitations under the License.
 ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~*/
var TitleV2Component = /** @class */ (function (_super) {
    __extends(TitleV2Component, _super);
    function TitleV2Component() {
        var _this = _super !== null && _super.apply(this, arguments) || this;
        _this.baseCssClass = 'cmp-title';
        _this.linkDisabled = false;
        _this.type = 'h3';
        return _this;
    }
    Object.defineProperty(TitleV2Component.prototype, "isEmpty", {
        get: function () {
            return TitleV2IsEmptyFn(this);
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(TitleV2Component.prototype, "hasLink", {
        get: function () {
            return !!this.linkURL && this.linkURL.trim().length > 0;
        },
        enumerable: true,
        configurable: true
    });
    __decorate([
        Input(),
        __metadata("design:type", Object)
    ], TitleV2Component.prototype, "baseCssClass", void 0);
    __decorate([
        Input(),
        __metadata("design:type", Object)
    ], TitleV2Component.prototype, "text", void 0);
    __decorate([
        Input(),
        __metadata("design:type", Object)
    ], TitleV2Component.prototype, "linkURL", void 0);
    __decorate([
        Input(),
        __metadata("design:type", Object)
    ], TitleV2Component.prototype, "linkDisabled", void 0);
    __decorate([
        Input(),
        __metadata("design:type", Object)
    ], TitleV2Component.prototype, "type", void 0);
    TitleV2Component = __decorate([
        Component({
            selector: 'core-title-v2',
            template: "<!--/*~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~\n  ~ Copyright 2020 Adobe\n  ~\n  ~ Licensed under the Apache License, Version 2.0 (the \"License\");\n  ~ you may not use this file except in compliance with the License.\n  ~ You may obtain a copy of the License at\n  ~\n  ~     http://www.apache.org/licenses/LICENSE-2.0\n  ~\n  ~ Unless required by applicable law or agreed to in writing, software\n  ~ distributed under the License is distributed on an \"AS IS\" BASIS,\n  ~ WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.\n  ~ See the License for the specific language governing permissions and\n  ~ limitations under the License.\n  ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~*/-->\n\n<div *ngIf=\"isEmpty; then placeHolderBlock else componentBlock\"></div>\n\n<ng-template #placeHolderBlock>\n    <core-placeholder *ngIf=\"shouldShowPlaceHolder\" componentTitle=\"TitleV2\"></core-placeholder>\n</ng-template>\n\n<ng-template #componentBlock>\n    <div *ngIf=\"hasLink; else heading\" id=\"{{id}}\" class=\"{{baseCssClass}}\" [attr.data-cmp-data-layer]=\"dataLayerString\">\n        <a *ngIf=\"routed\" class=\"{{baseCssClass}}__item-link\"\n           routerLink=\"{{ linkURL}}\"\n           routerLinkActive=\"active\">\n            <ng-container *ngTemplateOutlet=\"heading\"></ng-container>\n        </a>\n        <a *ngIf=\"!routed\" href=\"{{linkURL}}\" class=\"{{baseCssClass}}__item-link\">\n            <ng-container *ngTemplateOutlet=\"heading\"></ng-container>\n        </a>\n    </div>\n</ng-template>\n\n<ng-template #heading>\n    <div [ngSwitch]=\"type\" id=\"{{id}}\" class=\"{{baseCssClass}}\" [attr.data-cmp-data-layer]=\"dataLayerString\">\n        <h1 class=\"{{baseCssClass}}__text\" *ngSwitchCase=\"'h1'\">{{text}}</h1>\n        <h2 class=\"{{baseCssClass}}__text\" *ngSwitchCase=\"'h2'\">{{text}}</h2>\n        <h4 class=\"{{baseCssClass}}__text\" *ngSwitchCase=\"'h4'\">{{text}}</h4>\n        <h5 class=\"{{baseCssClass}}__text\" *ngSwitchCase=\"'h5'\">{{text}}</h5>\n        <h6 class=\"{{baseCssClass}}__text\" *ngSwitchCase=\"'h6'\">{{text}}</h6>\n        <h3 class=\"{{baseCssClass}}__text\" *ngSwitchDefault>{{text}}</h3>\n    </div>\n</ng-template>\n"
        })
    ], TitleV2Component);
    return TitleV2Component;
}(AbstractRoutedCoreComponent));

/*~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
 ~ Copyright 2020 Adobe Systems Incorporated
 ~
 ~ Licensed under the Apache License, Version 2.0 (the "License");
 ~ you may not use this file except in compliance with the License.
 ~ You may obtain a copy of the License at
 ~
 ~     http://www.apache.org/licenses/LICENSE-2.0
 ~
 ~ Unless required by applicable law or agreed to in writing, software
 ~ distributed under the License is distributed on an "AS IS" BASIS,
 ~ WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 ~ See the License for the specific language governing permissions and
 ~ limitations under the License.
 ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~*/
var AemAngularCoreWcmComponentsTitleV2 = /** @class */ (function () {
    function AemAngularCoreWcmComponentsTitleV2() {
    }
    AemAngularCoreWcmComponentsTitleV2 = __decorate([
        NgModule({
            imports: [CommonModule, BrowserModule, RouterModule, AemAngularCoreWcmComponentsCore],
            declarations: [
                TitleV2Component
            ],
            exports: [
                TitleV2Component
            ],
            entryComponents: [
                TitleV2Component,
            ],
        })
    ], AemAngularCoreWcmComponentsTitleV2);
    return AemAngularCoreWcmComponentsTitleV2;
}());

/*~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
 ~ Copyright 2020 Adobe Systems Incorporated
 ~
 ~ Licensed under the Apache License, Version 2.0 (the "License");
 ~ you may not use this file except in compliance with the License.
 ~ You may obtain a copy of the License at
 ~
 ~     http://www.apache.org/licenses/LICENSE-2.0
 ~
 ~ Unless required by applicable law or agreed to in writing, software
 ~ distributed under the License is distributed on an "AS IS" BASIS,
 ~ WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 ~ See the License for the specific language governing permissions and
 ~ limitations under the License.
 ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~*/

/**
 * Generated bundle index. Do not edit.
 */

export { AemAngularCoreWcmComponentsTitleV2, TitleV2Component };
//# sourceMappingURL=adobe-aem-core-components-angular-base-authoring-title-v2.js.map
