import { __decorate, __metadata, __extends } from 'tslib';
import { Input, Component, Pipe, InjectionToken, Injectable, NgModule } from '@angular/core';
import { DomSanitizer, BrowserModule } from '@angular/platform-browser';
import { CommonModule } from '@angular/common';
import { RouterModule } from '@angular/router';

/*~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
 ~ Copyright 2020 Adobe Systems Incorporated
 ~
 ~ Licensed under the Apache License, Version 2.0 (the "License");
 ~ you may not use this file except in compliance with the License.
 ~ You may obtain a copy of the License at
 ~
 ~     http://www.apache.org/licenses/LICENSE-2.0
 ~
 ~ Unless required by applicable law or agreed to in writing, software
 ~ distributed under the License is distributed on an "AS IS" BASIS,
 ~ WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 ~ See the License for the specific language governing permissions and
 ~ limitations under the License.
 ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~*/
var EditPlaceholderComponent = /** @class */ (function () {
    function EditPlaceholderComponent() {
    }
    EditPlaceholderComponent_1 = EditPlaceholderComponent;
    Object.defineProperty(EditPlaceholderComponent.prototype, "emptyText", {
        get: function () {
            var part1 = (this.componentTitle != null && this.componentTitle.length > 0) ? this.componentTitle + ' - ' : '';
            var part2 = (this.emptyTextAppend != null) ? this.emptyTextAppend : EditPlaceholderComponent_1.DEFAULT_EMPTY_TEXT_LABEL;
            return part1 + part2;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(EditPlaceholderComponent.prototype, "placeHolderCssClass", {
        get: function () {
            return 'cq-placeholder ' + this.classAppend;
        },
        enumerable: true,
        configurable: true
    });
    var EditPlaceholderComponent_1;
    EditPlaceholderComponent.DEFAULT_EMPTY_TEXT_LABEL = 'Please configure the component';
    __decorate([
        Input(),
        __metadata("design:type", String)
    ], EditPlaceholderComponent.prototype, "classAppend", void 0);
    __decorate([
        Input(),
        __metadata("design:type", String)
    ], EditPlaceholderComponent.prototype, "componentTitle", void 0);
    __decorate([
        Input(),
        __metadata("design:type", String)
    ], EditPlaceholderComponent.prototype, "emptyTextAppend", void 0);
    EditPlaceholderComponent = EditPlaceholderComponent_1 = __decorate([
        Component({
            selector: 'core-placeholder',
            template: "<!--/*~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~\n  ~ Copyright 2020 Adobe\n  ~\n  ~ Licensed under the Apache License, Version 2.0 (the \"License\");\n  ~ you may not use this file except in compliance with the License.\n  ~ You may obtain a copy of the License at\n  ~\n  ~     http://www.apache.org/licenses/LICENSE-2.0\n  ~\n  ~ Unless required by applicable law or agreed to in writing, software\n  ~ distributed under the License is distributed on an \"AS IS\" BASIS,\n  ~ WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.\n  ~ See the License for the specific language governing permissions and\n  ~ limitations under the License.\n  ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~*/-->\n\n<div [ngClass]=\"placeHolderCssClass\">{{emptyText}}</div>"
        })
    ], EditPlaceholderComponent);
    return EditPlaceholderComponent;
}());

/*~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
 ~ Copyright 2020 Adobe Systems Incorporated
 ~
 ~ Licensed under the Apache License, Version 2.0 (the "License");
 ~ you may not use this file except in compliance with the License.
 ~ You may obtain a copy of the License at
 ~
 ~     http://www.apache.org/licenses/LICENSE-2.0
 ~
 ~ Unless required by applicable law or agreed to in writing, software
 ~ distributed under the License is distributed on an "AS IS" BASIS,
 ~ WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 ~ See the License for the specific language governing permissions and
 ~ limitations under the License.
 ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~*/
var SafeHtmlPipe = /** @class */ (function () {
    function SafeHtmlPipe(sanitizer) {
        this.sanitizer = sanitizer;
    }
    SafeHtmlPipe.prototype.transform = function (style) {
        return this.sanitizer.bypassSecurityTrustHtml(style);
    };
    SafeHtmlPipe.ctorParameters = function () { return [
        { type: DomSanitizer }
    ]; };
    SafeHtmlPipe = __decorate([
        Pipe({ name: 'safeHtml' }),
        __metadata("design:paramtypes", [DomSanitizer])
    ], SafeHtmlPipe);
    return SafeHtmlPipe;
}());

/*~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
 ~ Copyright 2020 Adobe Systems Incorporated
 ~
 ~ Licensed under the Apache License, Version 2.0 (the "License");
 ~ you may not use this file except in compliance with the License.
 ~ You may obtain a copy of the License at
 ~
 ~     http://www.apache.org/licenses/LICENSE-2.0
 ~
 ~ Unless required by applicable law or agreed to in writing, software
 ~ distributed under the License is distributed on an "AS IS" BASIS,
 ~ WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 ~ See the License for the specific language governing permissions and
 ~ limitations under the License.
 ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~*/
var NAVIGATION_UTIL_SERVICE = new InjectionToken('NAVIGATION_UTIL_SERVICE');
var DefaultNavigationUtilityServiceImpl = /** @class */ (function () {
    function DefaultNavigationUtilityServiceImpl() {
    }
    /**
     * You may overrule this method to determine for example based on current URL / page context whether the item is active.
     * @param item
     */
    DefaultNavigationUtilityServiceImpl.prototype.isItemActive = function (item) {
        return item.active;
    };
    DefaultNavigationUtilityServiceImpl = __decorate([
        Injectable()
    ], DefaultNavigationUtilityServiceImpl);
    return DefaultNavigationUtilityServiceImpl;
}());

/*~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
 ~ Copyright 2020 Adobe Systems Incorporated
 ~
 ~ Licensed under the Apache License, Version 2.0 (the "License");
 ~ you may not use this file except in compliance with the License.
 ~ You may obtain a copy of the License at
 ~
 ~     http://www.apache.org/licenses/LICENSE-2.0
 ~
 ~ Unless required by applicable law or agreed to in writing, software
 ~ distributed under the License is distributed on an "AS IS" BASIS,
 ~ WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 ~ See the License for the specific language governing permissions and
 ~ limitations under the License.
 ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~*/
var AemAngularCoreWcmComponentsCore = /** @class */ (function () {
    function AemAngularCoreWcmComponentsCore() {
    }
    AemAngularCoreWcmComponentsCore = __decorate([
        NgModule({
            imports: [CommonModule, BrowserModule, RouterModule],
            providers: [
                { provide: NAVIGATION_UTIL_SERVICE, useClass: DefaultNavigationUtilityServiceImpl }
            ],
            exports: [
                EditPlaceholderComponent,
                SafeHtmlPipe
            ],
            declarations: [
                EditPlaceholderComponent,
                SafeHtmlPipe
            ],
            entryComponents: [
                EditPlaceholderComponent,
            ],
        })
    ], AemAngularCoreWcmComponentsCore);
    return AemAngularCoreWcmComponentsCore;
}());

/*
 *  Copyright 2020 Adobe
 *
 *  Licensed under the Apache License, Version 2.0 (the "License");
 *  you may not use this file except in compliance with the License.
 *  You may obtain a copy of the License at
 *
 *      http://www.apache.org/licenses/LICENSE-2.0
 *
 *  Unless required by applicable law or agreed to in writing, software
 *  distributed under the License is distributed on an "AS IS" BASIS,
 *  WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 *  See the License for the specific language governing permissions and
 *  limitations under the License.
 */
var MetaUtils = /** @class */ (function () {
    function MetaUtils() {
    }
    /**
     * Returns if the code executes in the browser context or not by checking for the
     * existance of the window object
     *
     * @returns {Boolean} the result of the check of the existance of the window object
     */
    MetaUtils.isBrowser = function () {
        try {
            return typeof window !== 'undefined';
        }
        catch (e) {
            return false;
        }
    };
    MetaUtils.getWcmMode = function () {
        return MetaUtils.getMetaPropertyValue('cq:wcmmode');
    };
    MetaUtils.isInEditor = function () {
        return this.getWcmMode() === 'edit';
    };
    /**
     * Returns the value of the meta property with the given key
     *
     * @param {string} propertyName  - name of the meta property
     * @return {string|undefined}
     */
    MetaUtils.getMetaPropertyValue = function (propertyName) {
        if (this.isBrowser()) {
            var meta = document.head.querySelector('meta[property="' + propertyName + '"]');
            // @ts-ignore
            return meta && meta.content;
        }
    };
    return MetaUtils;
}());

/*~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
 ~ Copyright 2020 Adobe Systems Incorporated
 ~
 ~ Licensed under the Apache License, Version 2.0 (the "License");
 ~ you may not use this file except in compliance with the License.
 ~ You may obtain a copy of the License at
 ~
 ~     http://www.apache.org/licenses/LICENSE-2.0
 ~
 ~ Unless required by applicable law or agreed to in writing, software
 ~ distributed under the License is distributed on an "AS IS" BASIS,
 ~ WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 ~ See the License for the specific language governing permissions and
 ~ limitations under the License.
 ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~*/
/**
 * AbstractCoreComponent
 * provides shared functionality / properties across all core component controllers
 */
var AbstractCoreComponent = /** @class */ (function () {
    function AbstractCoreComponent() {
        /** Force disable the placeholder at all times. This is useful for nested components. **/
        this.hidePlaceHolder = false;
        this.cqForceReload = false;
        this.dataLayer = {};
    }
    Object.defineProperty(AbstractCoreComponent.prototype, "shouldShowPlaceHolder", {
        /**
         * Returns whether to show the placeholder for the editors, if we cannot display the component.
         */
        get: function () {
            return (this.isEmpty && this.isInEditor === true && this.hidePlaceHolder !== true);
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(AbstractCoreComponent.prototype, "isInEditor", {
        get: function () {
            return MetaUtils.isInEditor();
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(AbstractCoreComponent.prototype, "dataLayerString", {
        get: function () {
            return this.dataLayer ? JSON.stringify(this.dataLayer) : "";
        },
        enumerable: true,
        configurable: true
    });
    __decorate([
        Input(),
        __metadata("design:type", Boolean)
    ], AbstractCoreComponent.prototype, "hidePlaceHolder", void 0);
    __decorate([
        Input(),
        __metadata("design:type", Object)
    ], AbstractCoreComponent.prototype, "cqForceReload", void 0);
    __decorate([
        Input(),
        __metadata("design:type", Object)
    ], AbstractCoreComponent.prototype, "cqPath", void 0);
    __decorate([
        Input(),
        __metadata("design:type", String)
    ], AbstractCoreComponent.prototype, "id", void 0);
    __decorate([
        Input(),
        __metadata("design:type", Object)
    ], AbstractCoreComponent.prototype, "baseCssClass", void 0);
    __decorate([
        Input(),
        __metadata("design:type", Object)
    ], AbstractCoreComponent.prototype, "dataLayer", void 0);
    return AbstractCoreComponent;
}());

/*~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
 ~ Copyright 2020 Adobe Systems Incorporated
 ~
 ~ Licensed under the Apache License, Version 2.0 (the "License");
 ~ you may not use this file except in compliance with the License.
 ~ You may obtain a copy of the License at
 ~
 ~     http://www.apache.org/licenses/LICENSE-2.0
 ~
 ~ Unless required by applicable law or agreed to in writing, software
 ~ distributed under the License is distributed on an "AS IS" BASIS,
 ~ WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 ~ See the License for the specific language governing permissions and
 ~ limitations under the License.
 ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~*/
/**
 * AbstractRoutedCoreComponent
 * This core component contains 1 or more links.
 * We want to be able to control SPA routing with a property coming from the model.
 */
var AbstractRoutedCoreComponent = /** @class */ (function (_super) {
    __extends(AbstractRoutedCoreComponent, _super);
    function AbstractRoutedCoreComponent() {
        return _super !== null && _super.apply(this, arguments) || this;
    }
    /**
     * Determine if an individual item (such as navigation entry or list link) should be routed or not.
     *
     * item: the entry item in a component, think of a link that belongs to a collection of links in the navigation.
     *       we can specify here to disable routing, or to overrule routing of the base component
     * base component: the component itself, think of the navigation itself.
     *       we can specify the default behaviour of all items here.
     *
     * The following scenarios result in routing:
     * Scenario 1: The item or the base component don't have anything set, we assume true (except for external links starting with http)
     * Scenario 2: The base component has routing on false, but the item has it on true (item takes precedence)
     * Scenario 3: The base component or item, or both, have the routing values set to true.
     *
     * The following scenario does NOT result in routing:
     * Scenario 1: The base component has routing enabled, but the item has it set to false
     * @param item
     */
    AbstractRoutedCoreComponent.prototype.isItemRouted = function (item) {
        var itemRoutedSpecified = typeof item.routed === 'boolean';
        var componentRoutedSpecified = typeof this.routed === 'boolean';
        if (!itemRoutedSpecified && !componentRoutedSpecified) {
            //if nothing specified, assume we route.
            return true;
        }
        else if (itemRoutedSpecified) {
            //only the item is specified
            return item.routed;
        }
        else if (componentRoutedSpecified) {
            return this.routed;
        }
    };
    __decorate([
        Input(),
        __metadata("design:type", Object)
    ], AbstractRoutedCoreComponent.prototype, "routed", void 0);
    return AbstractRoutedCoreComponent;
}(AbstractCoreComponent));

function ButtonV1IsEmptyFn(props) {
    return props.text == null || props.text.trim().length === 0;
}

function DefaultV1IsEmptyFn(props) {
    return props.html == null || props.html.trim().length === 0;
}

function DownloadV1IsEmptyFn(props) {
    return props.url == null || props.url.trim().length === 0;
}

function ImageV2IsEmptyFn(props) {
    return (!props.src) || props.src.length === 0;
}

function ListV2IsEmptyFn(props) {
    return props.items == null || props.items.length === 0;
}

function SeparatorV1IsEmptyFn() {
    return false;
}

function TeaserV1IsEmptyFn(props) {
    return !props.title || !props.description;
}

function TextV2IsEmptyFn(props) {
    return props.text == null || props.text.trim().length === 0;
}

function TitleV2IsEmptyFn(props) {
    return props.text == null || props.text.trim().length === 0;
}

function BreadCrumbV2IsEmptyFn(props) {
    return props.items == null || props.items.length === 0;
}

function NavigationV1IsEmptyFn(props) {
    return props.items == null || props.items.length === 0;
}

/*~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
 ~ Copyright 2020 Adobe Systems Incorporated
 ~
 ~ Licensed under the Apache License, Version 2.0 (the "License");
 ~ you may not use this file except in compliance with the License.
 ~ You may obtain a copy of the License at
 ~
 ~     http://www.apache.org/licenses/LICENSE-2.0
 ~
 ~ Unless required by applicable law or agreed to in writing, software
 ~ distributed under the License is distributed on an "AS IS" BASIS,
 ~ WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 ~ See the License for the specific language governing permissions and
 ~ limitations under the License.
 ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~*/

/**
 * Generated bundle index. Do not edit.
 */

export { AbstractCoreComponent, AbstractRoutedCoreComponent, AemAngularCoreWcmComponentsCore, BreadCrumbV2IsEmptyFn, ButtonV1IsEmptyFn, DefaultNavigationUtilityServiceImpl, DefaultV1IsEmptyFn, DownloadV1IsEmptyFn, EditPlaceholderComponent, ImageV2IsEmptyFn, ListV2IsEmptyFn, MetaUtils, NAVIGATION_UTIL_SERVICE, NavigationV1IsEmptyFn, SafeHtmlPipe, SeparatorV1IsEmptyFn, TeaserV1IsEmptyFn, TextV2IsEmptyFn, TitleV2IsEmptyFn };
//# sourceMappingURL=adobe-aem-core-components-angular-base-core.js.map
