import { __extends, __decorate, __metadata, __param } from 'tslib';
import { Inject, Input, Component, NgModule } from '@angular/core';
import { BreadCrumbV2IsEmptyFn, NAVIGATION_UTIL_SERVICE, AbstractRoutedCoreComponent, AemAngularCoreWcmComponentsCore } from '@adobe/aem-core-components-angular-base/core';
export { BreadCrumbV2IsEmptyFn } from '@adobe/aem-core-components-angular-base/core';
import { CommonModule } from '@angular/common';
import { BrowserModule } from '@angular/platform-browser';
import { RouterModule } from '@angular/router';

/*
 *  Copyright 2020 Adobe
 *
 *  Licensed under the Apache License, Version 2.0 (the "License");
 *  you may not use this file except in compliance with the License.
 *  You may obtain a copy of the License at
 *
 *      http://www.apache.org/licenses/LICENSE-2.0
 *
 *  Unless required by applicable law or agreed to in writing, software
 *  distributed under the License is distributed on an "AS IS" BASIS,
 *  WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 *  See the License for the specific language governing permissions and
 *  limitations under the License.
 */
var BreadCrumbV2Component = /** @class */ (function (_super) {
    __extends(BreadCrumbV2Component, _super);
    function BreadCrumbV2Component(navigationUtilService) {
        var _this = _super.call(this) || this;
        _this.baseCssClass = 'cmp-breadcrumb';
        _this.navigationUtilService = navigationUtilService;
        return _this;
    }
    Object.defineProperty(BreadCrumbV2Component.prototype, "isEmpty", {
        get: function () {
            return BreadCrumbV2IsEmptyFn(this);
        },
        enumerable: true,
        configurable: true
    });
    BreadCrumbV2Component.prototype.getItemCssClass = function (item) {
        return this.navigationUtilService.isItemActive(item) ? this.baseCssClass + '__item ' + this.baseCssClass + '__item--active' : this.baseCssClass + '__item';
    };
    BreadCrumbV2Component.ctorParameters = function () { return [
        { type: undefined, decorators: [{ type: Inject, args: [NAVIGATION_UTIL_SERVICE,] }] }
    ]; };
    __decorate([
        Input(),
        __metadata("design:type", Object)
    ], BreadCrumbV2Component.prototype, "baseCssClass", void 0);
    __decorate([
        Input(),
        __metadata("design:type", Object)
    ], BreadCrumbV2Component.prototype, "items", void 0);
    __decorate([
        Input(),
        __metadata("design:type", Object)
    ], BreadCrumbV2Component.prototype, "ariaLabelI18n", void 0);
    BreadCrumbV2Component = __decorate([
        Component({
            selector: 'core-breadcrumb-v2',
            template: "<!--/*~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~\n  ~ Copyright 2020 Adobe\n  ~\n  ~ Licensed under the Apache License, Version 2.0 (the \"License\");\n  ~ you may not use this file except in compliance with the License.\n  ~ You may obtain a copy of the License at\n  ~\n  ~     http://www.apache.org/licenses/LICENSE-2.0\n  ~\n  ~ Unless required by applicable law or agreed to in writing, software\n  ~ distributed under the License is distributed on an \"AS IS\" BASIS,\n  ~ WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.\n  ~ See the License for the specific language governing permissions and\n  ~ limitations under the License.\n  ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~*/-->\n\n<div *ngIf=\"isEmpty; then placeHolderBlock else componentBlock\"></div>\n\n<ng-template #placeHolderBlock>\n    <core-placeholder *ngIf=\"shouldShowPlaceHolder\" componentTitle=\"BreadCrumbV2\"></core-placeholder>\n</ng-template>\n\n<ng-template #componentBlock>\n    <nav id=\"{{id}}\"\n         class=\"{{baseCssClass}}\"\n         role=\"navigation\"\n         itemscope=\"\"\n         itemtype=\"http://schema.org/SiteNavigationElement\"\n         [attr.aria-label]=\"ariaLabelI18n\"\n         [attr.data-cmp-data-layer]=\"dataLayerString\"\n    >\n        <ol class=\"{{baseCssClass}}__list\">\n            <ng-container *ngFor=\"let item of items; let i = index\">\n                <li [ngClass]=\"getItemCssClass(item)\">\n    \n                    <ng-container *ngIf=\"isItemRouted(item) && !item.active\" [ngTemplateOutlet]=\"routedLink\" [ngTemplateOutletContext]=\"{item:item}\"></ng-container>\n                    <ng-container *ngIf=\"!isItemRouted(item) && !item.active\" [ngTemplateOutlet]=\"staticLink\" [ngTemplateOutletContext]=\"{item:item}\"></ng-container>\n                    <ng-container *ngIf=\"item.active\" [ngTemplateOutlet]=\"title\" [ngTemplateOutletContext]=\"{item:item}\"></ng-container>\n                    \n                    <meta itemProp=\"position\" content=\"{{i}}\"/>\n                </li>\n            </ng-container>\n        </ol>\n    </nav>\n</ng-template>\n\n<ng-template #routedLink let-item='item'>\n    <a class=\"{{baseCssClass}}__item-link\"\n       routerLink=\"{{ item.url }}\"\n       routerLinkActive=\"active\">\n        <ng-container [ngTemplateOutlet]=\"title\" [ngTemplateOutletContext]=\"{item:item}\"></ng-container>\n    </a>\n</ng-template>\n\n\n<ng-template #staticLink let-item='item'>\n    <a class=\"{{baseCssClass}}__item-link\"\n       href=\"{{item.url}}\">\n        <ng-container [ngTemplateOutlet]=\"title\" [ngTemplateOutletContext]=\"{item:item}\"></ng-container>\n    </a>\n</ng-template>\n\n\n<ng-template #title let-item='item'>\n    <span itemProp=\"name\">{{item.title}}</span>\n</ng-template>"
        }),
        __param(0, Inject(NAVIGATION_UTIL_SERVICE)),
        __metadata("design:paramtypes", [Object])
    ], BreadCrumbV2Component);
    return BreadCrumbV2Component;
}(AbstractRoutedCoreComponent));

var AemAngularCoreWcmComponentsBreadCrumbV2 = /** @class */ (function () {
    function AemAngularCoreWcmComponentsBreadCrumbV2() {
    }
    AemAngularCoreWcmComponentsBreadCrumbV2 = __decorate([
        NgModule({
            imports: [CommonModule, BrowserModule, RouterModule, AemAngularCoreWcmComponentsCore],
            declarations: [
                BreadCrumbV2Component
            ],
            exports: [
                BreadCrumbV2Component
            ],
            entryComponents: [
                BreadCrumbV2Component,
            ],
        })
    ], AemAngularCoreWcmComponentsBreadCrumbV2);
    return AemAngularCoreWcmComponentsBreadCrumbV2;
}());

/**
 * Generated bundle index. Do not edit.
 */

export { AemAngularCoreWcmComponentsBreadCrumbV2, BreadCrumbV2Component };
//# sourceMappingURL=adobe-aem-core-components-angular-base-layout-breadcrumb-v2.js.map
